//=============================================================================
// CNaliFruit.
//=============================================================================
class CNaliFruit expands CHealth
config (MH2_NS_V2);

var() bool bGrowWhenSeen;
var config int MaxHealth;
var config int HealingAmount;
function PostBeginPlay()
{
	Super.PostBeginPlay();
	bStasis = bGrowWhenSeen;
}

event float BotDesireability(Pawn Bot)
{
	if ( HealingAmount < 3 )
		return 0;

	return Super.BotDesireability(Bot);
}

auto state Pickup
{
	function Timer()
	{
		HealingAmount += 2;
		SetTimer(0.5,True);
	}

	function Touch( actor Other )
	{
		local int HealMax;
	
		if ( !ValidTouch(Other) || (HealingAmount<2) )
			Return;

		if (Level.Game.LocalLog != None)
			Level.Game.LocalLog.LogPickup(Self, Pawn(Other));
		if (Level.Game.WorldLog != None)
			Level.Game.WorldLog.LogPickup(Self, Pawn(Other));

		HealMax = MaxHealth;
		if (Pawn(Other).Health < HealMax) 
		{
			Pawn(Other).Health += HealingAmount;
			if (Pawn(Other).Health > HealMax) Pawn(Other).Health = HealMax;
			Pawn(Other).ClientMessage(PickupMessage$HealingAmount, 'Pickup');
			PlaySound (PickupSound);
			SetRespawn();
			if ( Level.Game.Difficulty > 1 )
				Other.MakeNoise(0.1 * Level.Game.Difficulty);
		}
	}
Begin:
	PlayAnim('Root');
	FinishAnim();
	HealingAmount = 0;
	Sleep(FRand()*3);
	SetTimer(8.5,False);
	PlayAnim('Grow',0.036);
	FinishAnim();
	SetTimer(0.0,False);
	LoopAnim('Waver',0.1);
}

defaultproperties
{
     MaxHealth=500
     HealingAmount=0
     PickupMessage="You picked up a Nali Healing Fruit +"
     RespawnTime=5.000000
     PickupViewMesh=LodMesh'UnrealShare.NaliFruitMesh'
     RemoteRole=ROLE_DumbProxy
     Mesh=LodMesh'UnrealShare.NaliFruitMesh'
     AmbientGlow=64
     CollisionHeight=21.000000
}
