class MHRazorJack expands TournamentWeapon;

var bool clientanidone, bfirstfire;

function CheckVisibility()
{
	local Pawn PawnOwner;

	PawnOwner = Pawn(Owner);

	if ( PawnOwner != None )
		if ( Owner.bHidden && (PawnOwner.Health > 0) && (PawnOwner.Visibility < PawnOwner.Default.Visibility) )
		{
			Owner.bHidden = false;
			PawnOwner.Visibility = PawnOwner.Default.Visibility;
		}
}

//A.I. related combat - no comment for default suggestions
function float SuggestAttackStyle() //Make me understand why is not so good ... Except HitWalls troubles (-0.2 because of Ripper ?)
{
	local float EnemyDist;
	local Pawn P;

	P = Pawn(Owner);
	EnemyDist = VSize(P.Enemy.Location - P.Location);
		if ( EnemyDist < 1200)
			return 0.2;		//Can use it in attack if not too far... Including Skaarj ? :P ?
		else
			return 0;		//Else is a weapon anyway. Will be a noisy fight, isn't it ? If too far low chances to aim well.
							//Even hitting themselves is not a big deal - is not very powerfull so ignore a lil self damage if occurs...
}

function float SuggestDefenseStyle()
{
	return 0.2;
}

function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
{
	local Vector Start, X,Y,Z;

	if ( PlayerPawn(Owner) != None )
		PlayerPawn(Owner).ClientInstantFlash( -0.4, vect(500, 0, 650));
	Owner.MakeNoise(Pawn(Owner).SoundDampening);
	GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
	Start = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Z * Z; 
	AdjustedAim = pawn(owner).AdjustAim(ProjSpeed, Start, AimError, True, bWarn);  
	return Spawn(ProjClass,,, Start,AdjustedAim);  
}

simulated function TweenDown()
{
	if ( Mesh == PlayerViewMesh )
	{
		if ( IsAnimating() && (AnimSequence != '') && (GetAnimGroup(AnimSequence) == 'Select') )
			TweenAnim( AnimSequence, AnimFrame * 0.4 );
		else
			PlayAnim('Down', 1.0, 0.05);
	}
}

simulated function TweenToStill() //wierd bug...
{									// Ns > A wrapper is better than a null code. Eh...
	if ( Mesh != PlayerViewMesh )	// Do anything else you might have.
		Super.TweenToStill(); 
}

simulated function PlayFiring()
{
	if ( Mesh == PlayerViewMesh )
		PlayAnim( 'Fire', 0.7,0.05 );
}

simulated function PlayAltFiring()
{
	if ( Mesh == PlayerViewMesh )
	{
		PlayAnim('AltFire1', 0.9,0.05);
		bFirstFire = true;
	}
}

simulated function PlayRepeatFiring()
{
	if ( Mesh == PlayerViewMesh )
		PlayAnim('AltFire2', 0.4,0.05);
}

function AltFire( float Value )
{
	if (AmmoType.UseAmmo(1))
	{
		if ( Owner.bHidden )
			CheckVisibility();
		bPointing=True;
		PlayAltFiring();
		GotoState('AltFiring');
	}
}
///////////////////////////
state AltFiring
{
	ignores animend;

	function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
	{
		local Vector Start, X,Y,Z;    

		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		Start = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z; 
		AdjustedAim = Pawn(Owner).AdjustAim(ProjSpeed, Start, AimError, True, bWarn);  
		AdjustedAim.Roll += 12768;    
		RazorBlade(Spawn(ProjClass,,, Start,AdjustedAim));
	}

Begin:
	FinishAnim();

Repeater:
	ProjectileFire(AltProjectileClass,AltProjectileSpeed,bAltWarnTarget);
	PlayRepeatFiring();
	FinishAnim();
	if ( PlayerPawn(Owner) == None )
	{
		if ( (AmmoType != None) && (AmmoType.AmmoAmount <=0) )
		{
			Pawn(Owner).StopFiring();
			Pawn(Owner).SwitchToBestWeapon();
			if ( bChangeWeapon )
				GotoState('DownWeapon');
		}
		else if ( (Pawn(Owner).bAltFire == 0) || (FRand() > AltRefireRate) )
		{
			Pawn(Owner).StopFiring();
			GotoState('Idle');
		}
	}
	if ( (Pawn(Owner).bAltFire!=0) && (Pawn(Owner).Weapon==Self) && AmmoType.UseAmmo(1))
		Goto 'Repeater';
	PlayAnim('AltFire3', 0.9,0.05);
	FinishAnim();
	PlayAnim('Load',0.2,0.05);  
	FinishAnim();  
	if ( Pawn(Owner).bFire!=0 && Pawn(Owner).Weapon==Self) 
		Global.Fire(0);
	else
		GotoState('Idle');
}

state ClientAltFiring //animation stuff...
{
	simulated function AnimEnd()
	{
		if ( (Pawn(Owner) == None) || ((AmmoType != None) && (AmmoType.AmmoAmount <= 0)) )
		{
			if (!ClientAniDone)
			{ //for using two anims....
				PlayAnim('AltFire3', 0.9,0.05);
				ClientAniDone=true;
			}
			else
			{
				PlayAnim('Load',0.2,0.05);
				ClientAniDone=False;
				GotoState('');}
		}
		else if ( !bCanClientFire )
			GotoState('');
		else if ( Pawn(Owner).bFire != 0 )
		{
			if (!ClientAniDone)
			{ //for using two anims...
				PlayAnim('AltFire3', 0.9,0.05);
				ClientAniDone=true;
			}
			else
			{
				PlayAnim('Load',0.2,0.05);
				clientanidone=False;
				Global.ClientFire(0);
			}
		}
		else if (bfirstfire || Pawn(Owner).bAltFire != 0 )
		{
			PlayRepeatFiring();
			bFirstFire = false;
		} //stuff to know if the first fire...
		else
		{
		if (!ClientAniDone)
		{ //for using two anims....
			PlayAnim('AltFire3', 0.9,0.05);
			ClientAniDone=true;
		}
		else
		{
			PlayAnim('Load',0.2,0.05);
			ClientAniDone=False;
			GotoState('');}
		}
	}
}
///////////////////////////
simulated function PlayIdleAnim()
{
	LoopAnim('Idle', 0.4);
}

defaultproperties
{
     WeaponDescription="Classification: Skaarj Blade Launcher"
     AmmoName=Class'UnrealI.RazorAmmo'
     PickupAmmoCount=15
     FireOffset=(X=16.000000,Z=-15.000000)
     ProjectileClass=Class'MH2_NS_V2.MHRazorBlade'
     AltProjectileClass=Class'MH2_NS_V2.MHRazorBladeAlt'
     shakemag=120.000000
     AIRating=0.500000
     RefireRate=0.830000
     AltRefireRate=0.830000
     SelectSound=Sound'UnrealI.Razorjack.beam'
     DeathMessage="%k took a bloody chunk out of %o with the %w."
     AutoSwitchPriority=7
     InventoryGroup=7
     PickupMessage="You got the RazorJack."
     ItemName="RazorJack"
     PlayerViewOffset=(X=2.000000,Z=-0.900000)
     PlayerViewMesh=LodMesh'UnrealI.Razor'
     BobDamping=0.970000
     PickupViewMesh=LodMesh'UnrealI.RazPick'
     ThirdPersonMesh=LodMesh'UnrealI.Razor3rd'
     StatusIcon=Texture'Botpack.Icons.UseRazor'
     PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
     Icon=Texture'Botpack.Icons.UseRazor'
     Mesh=LodMesh'UnrealI.RazPick'
     bNoSmooth=False
     CollisionRadius=28.000000
     CollisionHeight=7.000000
     Mass=17.000000
}
